// Copyright IBM Corp. and LoopBack contributors 2018,2020. All Rights Reserved.
// Node module: @loopback/authorization
// This file is licensed under the MIT License.
// License text available at https://opensource.org/licenses/MIT

/**
 * A LoopBack 4 component for authorization support (Role based, Permission
 * based, Vote based)
 *
 * @remarks
 * To read on key building blocks read through
 * {@link https://loopback.io/doc/en/lb4/Loopback-component-authorization.html |LoopBack authorization docs}
 *
 * @packageDocumentation
 */

export * from './authorization-component';
export * from './authorize-interceptor';
export * from './decorators/authorize';
export * from './keys';
export * from './types';
